#--------------------------------------------------------------------------------------------------
#
# Project created by QtCreator 2013-10-14T16:33:15
# Avtor: Dominik Letnar, FERI R-IT (UN)
# DIPLOMSKA NALOGA
# SLO: Graficni uporabniski vmesnik za sahovnico DGT
# EN: Graphical user interface for DGT chessboard
#
#--------------------------------------------------------------------------------------------------

QT += core
QT += gui
QT += network # povezava internet
INCLUDEPATH += /usr/share/gsoap
# CONFIG += console # debug v console
LIBS *= ../libdgtnix.so # dodano za knjiznico dgtnix
LIBS += -lgsoap++ #wsSoap.nsmap

TARGET = diplomaDL
TEMPLATE = app

SOURCES +=\
           osnovnoOkno.cpp \
           sahovnicaOkno.cpp \
           soapC.cpp \
           soapClient.cpp \
           main.cpp \

HEADERS += osnovnoOkno.h \
           sahovnicaOkno.h \
           soapwsSoapProxy.h \
           soapH.h \
           soapStub.h \
           soapwsSoapObject.h

FORMS += osnovnoOkno.ui \
         sahovnicaOkno.ui

RESOURCES += \
             sahovnicaOkno.qrc

OTHER_FILES += \
               wsSoap.nsmap
