#include "sahovnicaOkno.h"
#include "ui_sahovnicaOkno.h"
#include "osnovnoOkno.h"
#include "ui_osnovnoOkno.h"
#include "../dgtnix.h"
#include <QSocketNotifier>
#include "soapH.h"
#include <stdio.h>
#include "wsSoap.nsmap"
using namespace std;

extern sahovnicaOkno *oknoDGT;
QSocketNotifier *dogodek = NULL;
int g_wtime;
int g_btime;
int g_wturn;

QList<QLabel*> ploscaDGT;
QList<string> pozicijaDGT;
bool prekinjenaIgra;

string casBeli = "";
string casCrni = "";
string igralecNaVrsti;
QString tempCasBeli;
QString tempCasCrni;

char stanjeNaPlosci[64];
char novoStanje[64];

sahovnicaOkno::sahovnicaOkno(QWidget *parent) : QWidget(parent), ui(new Ui::sahovnicaOkno)
{
    ui->setupUi(this);
    this->setFixedSize(this->size());
    this->setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowTitleHint);
    this->rezultatPovezave = -1;
    this->ui->lblBeliIgralec->setText("Igralec z belimi figrami: Ni podatka.");
    this->ui->lblCrniIgralec->setText("Igralec s crnimi figurami: Ni podatka.");
    this->ui->lblNaVrsti->setText("Ni podatka.");

    try
    {
        casBeli = "Ni podatka.";
        casCrni = "Ni podatka";
        igralecNaVrsti = "Ni podatka";
        this->posljiPodatkeCas();
    } catch (...) {}

    this->ustvariPolje();
    prekinjenaIgra = false;
    this->ui->btnNadaljuj->setEnabled(false);
    this->ui->btnPrekini->setEnabled(true);
}

sahovnicaOkno::~sahovnicaOkno() { delete ui; }

void sahovnicaOkno::setOkno(Ui::osnovnoOkno *o) { this->o = o; } // referenca na osnovnoOkno

int sahovnicaOkno::dobiUspesnoPovezavo() { return this->rezultatPovezave; }

void sahovnicaOkno::ustvariPolje()
{
    this->ui->lblPoljeA8->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeB8->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeC8->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeD8->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeE8->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeF8->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeG8->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeH8->setText("<img src=':/slike/siva.png' />");

    this->ui->lblPoljeA7->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeB7->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeC7->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeD7->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeE7->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeF7->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeG7->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeH7->setText("<img src=':/slike/bela.png' />");

    this->ui->lblPoljeA6->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeB6->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeC6->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeD6->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeE6->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeF6->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeG6->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeH6->setText("<img src=':/slike/siva.png' />");

    this->ui->lblPoljeA5->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeB5->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeC5->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeD5->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeE5->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeF5->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeG5->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeH5->setText("<img src=':/slike/bela.png' />");

    this->ui->lblPoljeA4->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeB4->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeC4->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeD4->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeE4->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeF4->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeG4->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeH4->setText("<img src=':/slike/siva.png' />");

    this->ui->lblPoljeA3->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeB3->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeC3->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeD3->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeE3->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeF3->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeG3->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeH3->setText("<img src=':/slike/bela.png' />");

    this->ui->lblPoljeA2->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeB2->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeC2->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeD2->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeE2->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeF2->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeG2->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeH2->setText("<img src=':/slike/siva.png' />");

    this->ui->lblPoljeA1->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeB1->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeC1->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeD1->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeE1->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeF1->setText("<img src=':/slike/bela.png' />");
    this->ui->lblPoljeG1->setText("<img src=':/slike/siva.png' />");
    this->ui->lblPoljeH1->setText("<img src=':/slike/bela.png' />");
}

void sahovnicaOkno::inicializacijaLabel()
{
    ploscaDGT.push_back(this->ui->lblFiguraA8);
    ploscaDGT.push_back(this->ui->lblFiguraB8);
    ploscaDGT.push_back(this->ui->lblFiguraC8);
    ploscaDGT.push_back(this->ui->lblFiguraD8);
    ploscaDGT.push_back(this->ui->lblFiguraE8);
    ploscaDGT.push_back(this->ui->lblFiguraF8);
    ploscaDGT.push_back(this->ui->lblFiguraG8);
    ploscaDGT.push_back(this->ui->lblFiguraH8);

    ploscaDGT.push_back(this->ui->lblFiguraA7);
    ploscaDGT.push_back(this->ui->lblFiguraB7);
    ploscaDGT.push_back(this->ui->lblFiguraC7);
    ploscaDGT.push_back(this->ui->lblFiguraD7);
    ploscaDGT.push_back(this->ui->lblFiguraE7);
    ploscaDGT.push_back(this->ui->lblFiguraF7);
    ploscaDGT.push_back(this->ui->lblFiguraG7);
    ploscaDGT.push_back(this->ui->lblFiguraH7);

    ploscaDGT.push_back(this->ui->lblFiguraA6);
    ploscaDGT.push_back(this->ui->lblFiguraB6);
    ploscaDGT.push_back(this->ui->lblFiguraC6);
    ploscaDGT.push_back(this->ui->lblFiguraD6);
    ploscaDGT.push_back(this->ui->lblFiguraE6);
    ploscaDGT.push_back(this->ui->lblFiguraF6);
    ploscaDGT.push_back(this->ui->lblFiguraG6);
    ploscaDGT.push_back(this->ui->lblFiguraH6);

    ploscaDGT.push_back(this->ui->lblFiguraA5);
    ploscaDGT.push_back(this->ui->lblFiguraB5);
    ploscaDGT.push_back(this->ui->lblFiguraC5);
    ploscaDGT.push_back(this->ui->lblFiguraD5);
    ploscaDGT.push_back(this->ui->lblFiguraE5);
    ploscaDGT.push_back(this->ui->lblFiguraF5);
    ploscaDGT.push_back(this->ui->lblFiguraG5);
    ploscaDGT.push_back(this->ui->lblFiguraH5);

    ploscaDGT.push_back(this->ui->lblFiguraA4);
    ploscaDGT.push_back(this->ui->lblFiguraB4);
    ploscaDGT.push_back(this->ui->lblFiguraC4);
    ploscaDGT.push_back(this->ui->lblFiguraD4);
    ploscaDGT.push_back(this->ui->lblFiguraE4);
    ploscaDGT.push_back(this->ui->lblFiguraF4);
    ploscaDGT.push_back(this->ui->lblFiguraG4);
    ploscaDGT.push_back(this->ui->lblFiguraH4);

    ploscaDGT.push_back(this->ui->lblFiguraA3);
    ploscaDGT.push_back(this->ui->lblFiguraB3);
    ploscaDGT.push_back(this->ui->lblFiguraC3);
    ploscaDGT.push_back(this->ui->lblFiguraD3);
    ploscaDGT.push_back(this->ui->lblFiguraE3);
    ploscaDGT.push_back(this->ui->lblFiguraF3);
    ploscaDGT.push_back(this->ui->lblFiguraG3);
    ploscaDGT.push_back(this->ui->lblFiguraH3);

    ploscaDGT.push_back(this->ui->lblFiguraA2);
    ploscaDGT.push_back(this->ui->lblFiguraB2);
    ploscaDGT.push_back(this->ui->lblFiguraC2);
    ploscaDGT.push_back(this->ui->lblFiguraD2);
    ploscaDGT.push_back(this->ui->lblFiguraE2);
    ploscaDGT.push_back(this->ui->lblFiguraF2);
    ploscaDGT.push_back(this->ui->lblFiguraG2);
    ploscaDGT.push_back(this->ui->lblFiguraH2);

    ploscaDGT.push_back(this->ui->lblFiguraA1);
    ploscaDGT.push_back(this->ui->lblFiguraB1);
    ploscaDGT.push_back(this->ui->lblFiguraC1);
    ploscaDGT.push_back(this->ui->lblFiguraD1);
    ploscaDGT.push_back(this->ui->lblFiguraE1);
    ploscaDGT.push_back(this->ui->lblFiguraF1);
    ploscaDGT.push_back(this->ui->lblFiguraG1);
    ploscaDGT.push_back(this->ui->lblFiguraH1);
}

void sahovnicaOkno::inicializacijaPozicij()
{
    pozicijaDGT.push_back("a8");
    pozicijaDGT.push_back("b8");
    pozicijaDGT.push_back("c8");
    pozicijaDGT.push_back("d8");
    pozicijaDGT.push_back("e8");
    pozicijaDGT.push_back("f8");
    pozicijaDGT.push_back("g8");
    pozicijaDGT.push_back("h8");

    pozicijaDGT.push_back("a7");
    pozicijaDGT.push_back("b7");
    pozicijaDGT.push_back("c7");
    pozicijaDGT.push_back("d7");
    pozicijaDGT.push_back("e7");
    pozicijaDGT.push_back("f7");
    pozicijaDGT.push_back("g7");
    pozicijaDGT.push_back("h7");

    pozicijaDGT.push_back("a6");
    pozicijaDGT.push_back("b6");
    pozicijaDGT.push_back("c6");
    pozicijaDGT.push_back("d6");
    pozicijaDGT.push_back("e6");
    pozicijaDGT.push_back("f6");
    pozicijaDGT.push_back("g6");
    pozicijaDGT.push_back("h6");

    pozicijaDGT.push_back("a5");
    pozicijaDGT.push_back("b5");
    pozicijaDGT.push_back("c5");
    pozicijaDGT.push_back("d5");
    pozicijaDGT.push_back("e5");
    pozicijaDGT.push_back("f5");
    pozicijaDGT.push_back("g5");
    pozicijaDGT.push_back("h5");

    pozicijaDGT.push_back("a4");
    pozicijaDGT.push_back("b4");
    pozicijaDGT.push_back("c4");
    pozicijaDGT.push_back("d4");
    pozicijaDGT.push_back("e4");
    pozicijaDGT.push_back("f4");
    pozicijaDGT.push_back("g4");
    pozicijaDGT.push_back("h4");

    pozicijaDGT.push_back("a3");
    pozicijaDGT.push_back("b3");
    pozicijaDGT.push_back("c3");
    pozicijaDGT.push_back("d3");
    pozicijaDGT.push_back("e3");
    pozicijaDGT.push_back("f3");
    pozicijaDGT.push_back("g3");
    pozicijaDGT.push_back("h3");

    pozicijaDGT.push_back("a2");
    pozicijaDGT.push_back("b2");
    pozicijaDGT.push_back("c2");
    pozicijaDGT.push_back("d2");
    pozicijaDGT.push_back("e2");
    pozicijaDGT.push_back("f2");
    pozicijaDGT.push_back("g2");
    pozicijaDGT.push_back("h2");

    pozicijaDGT.push_back("a1");
    pozicijaDGT.push_back("b1");
    pozicijaDGT.push_back("c1");
    pozicijaDGT.push_back("d1");
    pozicijaDGT.push_back("e1");
    pozicijaDGT.push_back("f1");
    pozicijaDGT.push_back("g1");
    pozicijaDGT.push_back("h1");
}

void sahovnicaOkno::vzpostaviPovezavo(const char* naprava)
{
    for(int i=0; i<64; i++)
        stanjeNaPlosci[i] = ' ';
    if (dogodek != NULL)
      delete dogodek;

    //dgtnixSetDebugMode(1); // nastavitev debug moznosti
    try
    {
        this->rezultatPovezave = dgtnixInit(naprava); // povezava
    }
    catch (...) {}

    if (dobiUspesnoPovezavo() >= 0)
    {
        this->inicializacijaLabel();
        this->inicializacijaPozicij();

        const char *trenutnoStanje = dgtnixGetBoard();
        for(int i=0; i<64;i++)
            stanjeNaPlosci[i] = trenutnoStanje[i];

        this->osveziPodatke(stanjeNaPlosci);

        dogodek = new QSocketNotifier(dobiUspesnoPovezavo(), QSocketNotifier::Read);
        dogodek->setEnabled(true);

        connect(dogodek, SIGNAL(activated(int)), oknoDGT, SLOT(upravljajDogodke(int)));

        for(int i=0; i<64; i++)
            novoStanje[i] = ' ';

        for (int i=0; i<64;i++)
            novoStanje[i] = trenutnoStanje[i];

        this->posljiPodatkePolja();
    }
}

void sahovnicaOkno::on_btnZapri_clicked()
{
    o->btnPrikazi->setVisible(true);
    o->btnPrikazi->setEnabled(true);
    this->close();
}

void sahovnicaOkno::upravljajDogodke(int tmp)
{
    try
    {
        if (prekinjenaIgra)
            return;

        char buffer;
        read(tmp, &buffer, 1);
        if (buffer == DGTNIX_MSG_TIME)
            this->posodobiCas();

        if ((buffer == DGTNIX_MSG_MV_REMOVE) || (buffer == DGTNIX_MSG_MV_ADD))
        {
            for(int i=0; i<64; i++)
                novoStanje[i] = ' ';

            const char *trenutnoStanje = dgtnixGetBoard();

            for (int i=0; i<64;i++)
                novoStanje[i] = trenutnoStanje[i];

            this->osveziPodatke(novoStanje);

            this->posljiPodatkePolja();
        }
    }
    catch (...) {}
}

void sahovnicaOkno::posljiPodatkePolja()
{
    try
    {
        string stanje; // deklaracija spremenljivke

        // ustvarjanje polja, ki ga bomo shranili v podatkovno zbirko
        for (int i=0; i<64; i++)
        {
            if (novoStanje[i] == ' ')
                stanje += '-';
            else
                stanje += novoStanje[i];
        }

        struct soap s; // ustvarimo objekt strukture tipa soap
        struct _ns1__setPoljeResponse spr; // ustvarimo objekt strukture za funkcijo setPoljeResponse
        struct _ns1__setPolje sp; // ustvarimo objekt strukture za funkcijo setPolje

        // funkcija setPolje dobi argument, ki ga nastavimo objekt.spremenljivka (spletna storitev)
        sp.polje = new std::string(stanje);
        soap_init(&s); // inicializacija

        soap_call___ns2__setPolje(&s, NULL, NULL, &sp, &spr); // klic funkcije

        // počistimo in uničimo
        soap_destroy(&s);
        soap_end(&s);
        soap_done(&s);
    }
    catch (...) {}
}

void sahovnicaOkno::posljiPodatkeCas()
{
    try
    {
        struct soap s;
        struct _ns1__setPodatkiResponse spr;
        struct _ns1__setPodatki sp;

        sp.casBeli = new std::string(casBeli);
        sp.casCrni = new std::string(casCrni);
        sp.igralecNaVrsti = new std::string(igralecNaVrsti);
        soap_init(&s);

        soap_call___ns2__setPodatki(&s, NULL, NULL, &sp, &spr);

        soap_destroy(&s);
        soap_end(&s);
        soap_done(&s);
    }
    catch (...) {}
}

void sahovnicaOkno::osveziPodatke(const char *stanje)
{
    for (int i=0; i<64; i++)
        ploscaDGT.at(i)->clear();

    for (int i=0; i<64; i++)
    {
        switch(stanje[i])
        {
            case ' ':
                break;
            case 'R':
                ploscaDGT.at(i)->setText("<img src=':/slike/velikiR.png' />");
                break;
            case 'N':
                ploscaDGT.at(i)->setText("<img src=':/slike/velikiN.png' />");
                break;
            case 'B':
                ploscaDGT.at(i)->setText("<img src=':/slike/velikiB.png' />");
                break;
            case 'K':
                ploscaDGT.at(i)->setText("<img src=':/slike/velikiK.png' />");
                break;
            case 'Q':
                ploscaDGT.at(i)->setText("<img src=':/slike/velikiQ.png' />");
                break;
            case 'P':
                ploscaDGT.at(i)->setText("<img src=':/slike/velikiP.png' />");
                break;
            case 'r':
                ploscaDGT.at(i)->setText("<img src=':/slike/maliR.png' />");
                break;
            case 'n':
                ploscaDGT.at(i)->setText("<img src=':/slike/maliN.png' />");
                break;
            case 'b':
                ploscaDGT.at(i)->setText("<img src=':/slike/maliB.png' />");
                break;
            case 'k':
                ploscaDGT.at(i)->setText("<img src=':/slike/maliK.png' />");
                break;
            case 'q':
                ploscaDGT.at(i)->setText("<img src=':/slike/maliQ.png' />");
                break;
            case 'p':
                ploscaDGT.at(i)->setText("<img src=':/slike/maliP.png' />");
                break;
        }
    }
}

string sahovnicaOkno::vrniCasBeli(int uraBeli, int minutaBeli, int sekundaBeli)
{
    string izpisCasBeli = "";
    if (uraBeli < 10)
        izpisCasBeli += "0" + (QString::number(uraBeli)).toStdString() + "h ";
    else
        izpisCasBeli += (QString::number(uraBeli)).toStdString() + "h ";

    if (minutaBeli < 10)
        izpisCasBeli += "0" + (QString::number(minutaBeli)).toStdString() + "min ";
    else
        izpisCasBeli += (QString::number(minutaBeli)).toStdString() + "min ";

    if (sekundaBeli < 10)
        izpisCasBeli += "0" + (QString::number(sekundaBeli)).toStdString() + "s";
    else
        izpisCasBeli += (QString::number(sekundaBeli)).toStdString() + "s";

    return izpisCasBeli;
}

string sahovnicaOkno::vrniCasCrni(int uraCrni, int minutaCrni, int sekundaCrni)
{
    string izpisCasCrni = "";
    if (uraCrni < 10)
        izpisCasCrni += "0" + (QString::number(uraCrni)).toStdString() + "h ";
    else
        izpisCasCrni += (QString::number(uraCrni)).toStdString() + "h ";

    if (minutaCrni < 10)
        izpisCasCrni += "0" + (QString::number(minutaCrni)).toStdString() + "min ";
    else
        izpisCasCrni += (QString::number(minutaCrni)).toStdString() + "min ";

    if (sekundaCrni < 10)
        izpisCasCrni += "0" + (QString::number(sekundaCrni)).toStdString() + "s";
    else
        izpisCasCrni += (QString::number(sekundaCrni)).toStdString() + "s";

    return izpisCasCrni;
}

void sahovnicaOkno::posodobiCas()
{
    if (g_btime == -1) // ce ni podatke, ni podatka o uri
    {
        this->ui->lblBeliIgralec->setText("Igralec z belimi figurami: Ni podatka.");
        this->ui->lblCrniIgralec->setText("Igralec s crnimi figurami: Ni podatka.");
        this->ui->lblNaVrsti->setText("Ni podatka.");

        try
        {
            casBeli = "Ni podatka.";
            casCrni = "Ni podatka.";
            igralecNaVrsti = "Ni podatka.";
            this->posljiPodatkeCas();
        }
        catch (...) {}
    }
    else
    {
        // preracunavanje casa
        int uraBeli = g_wtime / 3600;
        int minutaBeli = g_wtime / 60 - uraBeli * 60;
        int sekundaBeli = g_wtime % 60;

        int uraCrni = g_btime / 3600;
        int minutaCrni = g_btime / 60 - uraCrni * 60;
        int sekundaCrni = g_btime % 60;

        this->ui->lblBeliIgralec->clear();
        this->ui->lblCrniIgralec->clear();
        casBeli = "";
        casCrni = "";
        casBeli = this->vrniCasBeli(uraBeli, minutaBeli, sekundaBeli);
        casCrni = this->vrniCasCrni(uraCrni, minutaCrni, sekundaCrni);
        tempCasBeli = QString::fromStdString(casBeli);
        tempCasCrni = QString::fromStdString(casCrni);
        this->ui->lblBeliIgralec->setText("Igralec z belimi figurami: " + tempCasBeli);
        this->ui->lblCrniIgralec->setText("Igralec s crnimi figurami: " + tempCasCrni);

        // igralec na vrsti
        if (g_wturn == 1)
        {
            try
            {
                igralecNaVrsti = "Igralec z belimi figurami";
                this->posljiPodatkeCas();
            }
            catch (...) {}

            this->ui->lblNaVrsti->setText("Igralec z belimi figurami");
        }
        else
        {
            try
            {
                igralecNaVrsti = "Igralec s crnimi figurami";
                this->posljiPodatkeCas();
            }
            catch (...) {}

            this->ui->lblNaVrsti->setText("Igralec s crnimi figurami");
        }
    }
}

void sahovnicaOkno::on_btnNadaljuj_clicked()
{
    this->ui->btnNadaljuj->setEnabled(false);
    this->ui->btnPrekini->setEnabled(true);
    prekinjenaIgra = false;
}

void sahovnicaOkno::on_btnPrekini_clicked()
{
    this->ui->btnNadaljuj->setEnabled(true);
    this->ui->btnPrekini->setEnabled(false);
    prekinjenaIgra = true;
}
