#ifndef SAHOVNICAOKNO_H
#define SAHOVNICAOKNO_H

#include <QWidget>
#include "osnovnoOkno.h"
#include "ui_osnovnoOkno.h"
using namespace std;

namespace Ui { class sahovnicaOkno; }

class sahovnicaOkno : public QWidget
{
    Q_OBJECT
    
    public:
        explicit sahovnicaOkno(QWidget *parent = 0);
        ~sahovnicaOkno();

        int dobiUspesnoPovezavo();
        void vzpostaviPovezavo(const char* naprava);
        void setOkno(Ui::osnovnoOkno *o);
        void ustvariPolje();
        void inicializacijaLabel();
        void inicializacijaPozicij();
        void osveziPodatke(const char *stanje);
        void posljiPodatkePolja();
        void posljiPodatkeCas();
        void posodobiCas();
        string vrniCasBeli(int uraBeli, int minutaBeli, int sekundaBeli);
        string vrniCasCrni(int uraCrni, int minutaCrni, int sekundaCrni);

    public slots:
        void upravljajDogodke(int);

    private slots:
        void on_btnZapri_clicked();
        void on_btnNadaljuj_clicked();
        void on_btnPrekini_clicked();

private:
        Ui::sahovnicaOkno *ui;
        int rezultatPovezave;
        Ui::osnovnoOkno *o;
};

#endif // SAHOVNICAOKNO_H
